/*
 * ControlThread.java
 *
 * Created on 8. Dezember 2000, 10:46
 */
 


/** 
 *
 * @author  fhofmann
 * @version 
 */

import scheduler.*;

public class ControlThread extends SimProcess {

  /** Creates new ControlThread */
  public ControlThread(String name, Scheduler scheduler, int nodeNumber) {
    super(name, scheduler, nodeNumber);
    ((Algorithm)(scheduler.system)).addRow(name, nodeNumber, false);
    scheduler.createThread(this);
  }
  
  public void runProcess() {
    int i;
    while (true) {
      scheduler.suspend();
      for (i = 0; i < ((Algorithm)(scheduler.system)).getNumberOfNodes(); i++) {
	// SystemPrinter.println("Send REQUEST");
	((Connection)(outgoingConnections.elementAt(i))).send("NEXTROUND");
      }
    }
  }
}
