/*
 * SpecialThread.java
 *
 * Created on 31. Dezember 2000, 19:11
 */
 


/** 
 *
 * @author  fhofmann
 * @version 
 */

import java.awt.*;

import scheduler.*;
import sysPr.*;

public class SpecialThread extends SimProcess {

  /** Creates new SpecialThread */
  int n = ((Algorithm)(scheduler.system)).getNumberOfNodes();
  public int id = n;
  CommunicationGraph communicationGraph;
  
  public SpecialThread(String name, Scheduler scheduler, int nodeNumber, CommunicationGraph communicationGraph) {
    super(name, scheduler, nodeNumber);
    ((Algorithm)(scheduler.system)).addRow(name, nodeNumber, false);
    scheduler.createThread(this);
    this.communicationGraph = communicationGraph;
  }
  
  public void runProcess() {
    int i;
    while (scheduler.system.getSimulationTime() < 1) scheduler.schedule();
    
    while (true) {
      scheduler.suspend();
      for (i = 0; i < n; i++) {
        ((Connection)(outgoingConnections.elementAt(i))).send("NEXTROUND");
      }
    }
  }  
}