package scheduler;

import sysPr.*;

public class Semaphore extends ThreadList {
  Scheduler scheduler;
  int counter;
  String name;
  
  public Semaphore(int v, Scheduler scheduler) {
    super();
    this.scheduler = scheduler;
    counter = v;
  }
  
  public Semaphore(String name, int v, Scheduler scheduler) {
    super();
    this.scheduler = scheduler;
    counter = v;
    this.name = name;
  }
  
  public void p() {
    scheduler.beginOfAtomic();
      counter--;
      // SystemPrinter.println("p(); counter = " + counter);
      if (counter < 0) {
	// SystemPrinter.println("blocked; counter = " + counter);
	append(Thread.currentThread().getName());
        scheduler.suspend();
        // SystemPrinter.println("deblocked; counter = " + counter);
      } else
    scheduler.endOfAtomic();
  }
  
  public void v() {
    scheduler.beginOfAtomic();
      counter++;
      if (counter <= 0) {
	 String name = first();
	 remove();
	 scheduler.resume(name);
      }
    scheduler.endOfAtomic();
  }
}
