import scheduler.*;

public class Connection extends BasicConnection {

  public Connection(SimProcess source, SimProcess destination) {
    super(source, destination);
  }
  
  public Connection(SimProcess source, SimProcess destination,
		    Semaphore messageArrived) {
    super(source, destination, messageArrived);
  }
    
  public void send(String type) {
    Message message;
    if (type.equals("NEXTROUND")) {
      message = new  Message(source, destination, type, 0, 1);
    } else {  
      message = new  Message(source, destination, type, 0, 2);
    }
    // message.print(source.getName() + " ---> " + destination.getName() + ": ");
    xmit(message);
  }

  public void send(String type, int j) {
    Message message = new  Message(source, destination, type, j, 2);
    // message.print(source.getName() + " ---> " + destination.getName() + ": ");
    xmit(message);
  }

}
