/**
 * This class represents points in a two dimensional cartesian space 
 */

import sysPr.*;

public class Koord implements Cloneable
{
  public int x,y;

  public Koord(int x,int y) {
    this.x = x; 
    this.y = y;
  }
  
  public Koord () {}

  /**
    Return the coordinates got by mirroring the point on the 45 degree diagonal
   */
  public Koord inverse() {
    return new Koord(y,x);
  }

  public synchronized Object clone() {
    try {
          Koord k = (Koord)super.clone();
            return k;
        } catch (CloneNotSupportedException e) {
            throw new InternalError();
        }
  }
  
  public void print(String string) {
    SystemPrinter.println(string + ": x = " + x + ", " + y);
  }
}
